#include <Windows.h>
#include <math.h>
#include "ASIOHost.h"

// Enable this if you want to capture
// what you hear on first channel
// (captured as raw audio data in "out.pcm")
// #define CAPTURE_FIRST_CHANNEL

#define OUTDATA_BUFSIZE_SAMPLES 128
#define SAMPLES_FOR_ONE_PERIOD 100
#define TWO_PI (6.28318530717959) // PI * 2
#define Max16BitAmplitude (0x8000 >> 1)  // 16 bit audio down 6 dB
#define Max24BitAmplitude (0x800000 >> 1) // 24 bit audio down 6 dB
#define Max32BitAmplitude (0x80000000 >> 1) // 32 bit audio down 6 dB

class VirtualChannel
{
public:
 VirtualChannel(int nChannel);
 ~VirtualChannel();
 void PrepareVirtualChannel(void);
 void PrepareBuffers(void);
 void Start(void);
 void Stop(void);
 bool GetInitSuccess(void){return bInitSuccess;};

 // public static functions...
 static void InitClassVars(MODE modeReqd, bool bHiResSamples);

private:
 ChannelVars ChannelVars;
 LPBYTE pInputBuffer;
 DWORD dwCurSampleOffset;
 int nChannel;
 bool bCreatedVirtualChn;
 bool bInitSuccess;

 // private static functions...
 static void GetMonoSamples(LPBYTE pSndBuf, DWORD dwSamples);
 static void CopySineWaveOutput(LPBYTE pSndBuf, DWORD dwBufsizeBytes, LPDWORD pdwCurSampleOffset);

 // Callback functions...
 friend void RefillBuffer(LPBYTE pSndBuf, DWORD dwBufsizeBytes, DWORD dwInstanceData);
 friend void SaveBuffer(LPBYTE pSndBuf, DWORD dwBufsizeBytes, DWORD dwInstanceData);
};

typedef VirtualChannel *LPVIRTUALCHANNEL;